package com.ho.test.perf.measure.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


/**
 * Specify the class, interface or enum whose the performace must be measured and an admissible threshold (warning duration).
 * @author huseyin
 */
// RetentionPolicy.RUNTIME : Annotations are to be recorded in the class file by the compiler 
//			and retained by the VM at runtime, so they may be read reflectively.
// ElementType.TYPE : Class, interface (including annotationtype) or enum declaration
@Retention(RetentionPolicy.RUNTIME) 
@Target(ElementType.TYPE)
public @interface PerformanceWatcher {
	long msDurationWarning() default 1000;
}