package com.ho.test.perf.measure.commons.dao.hibernate;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ho.test.perf.measure.annotations.PerformanceWatcher;
import com.ho.test.perf.measure.utils.ApplicationContextContainer;

@PerformanceWatcher(msDurationWarning=2000)
public class Business1DaoHibernateImpl implements IBusiness1 {
	
	private static Log log = LogFactory.getLog(Business1DaoHibernateImpl.class);
	
	/**
	 * Save or update object into database.
	 */
	public void saveOrUpdate() {
		log.info("Business1DaoHibernateImpl:saveOrUpdate START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business1DaoHibernateImpl:saveOrUpdate END");
	}
	/**
	 * Save object into database.
	 */
	public void save() {
		log.info("Business1DaoHibernateImpl:save START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business1DaoHibernateImpl:save END");
	}
	/**
	 * Update object into database.
	 */
	public void update() {
		log.info("Business1DaoHibernateImpl:update START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business1DaoHibernateImpl:update END");
	}

	/**
	 * Delete object into database.
	 */
	public void delete() {
		log.info("Business1DaoHibernateImpl:delete START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business1DaoHibernateImpl:delete END");
	}
}