package com.ho.test.perf.measure.commons.dao.hibernate;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ho.test.perf.measure.annotations.PerformanceWatcher;
import com.ho.test.perf.measure.utils.ApplicationContextContainer;

@PerformanceWatcher(msDurationWarning=3000)
public class Business2DaoHibernateImpl implements IBusiness2 {
	
	private static Log log = LogFactory.getLog(Business2DaoHibernateImpl.class);
	
	/**
	 * Save or update object into database.
	 */
	public void saveOrUpdate() {
		log.info("Business2DaoHibernateImpl:saveOrUpdate START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business2DaoHibernateImpl:saveOrUpdate END");
	}
	/**
	 * Save object into database.
	 */
	public void save() {
		log.info("Business2DaoHibernateImpl:save START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business2DaoHibernateImpl:save END");
	}
	/**
	 * Update object into database.
	 */
	public void update() {
		log.info("Business2DaoHibernateImpl:update START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business2DaoHibernateImpl:update END");
	}

	/**
	 * Delete object into database.
	 */
	public void delete() {
		log.info("Business2DaoHibernateImpl:delete START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("Business2DaoHibernateImpl:delete END");
	}
}