package com.ho.test.perf.measure.commons.jdbc;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ho.test.perf.measure.annotations.PerformanceWatcher;
import com.ho.test.perf.measure.utils.ApplicationContextContainer;


/**
 * Allows to use JDBCTemplate from SpringFramework to execute sql query in JDBC
 * @a2.Version
 */
@PerformanceWatcher(msDurationWarning=3500)
public class JdbcUtilsServiceImpl implements IJdbcUtils {
	// ----------------------------------------------------- PRIVATE ATTRIBUTES
	private static Log log = LogFactory.getLog(JdbcUtilsServiceImpl.class);

	// ------------------------------------------------------------- EXCEPTIONS
	// ------------------------------------------------------- INTERNAL CLASSES
	// ----------------------------------------------------------- CONSTRUCTORS
	// --------------------------------------------------------- PUBLIC METHODS
	/**
	 * Execute query.
	 * @param sql the sql
	 * @return the query execution result as a List
	 */
	public List executeQuery(String sql) {
		log.info("JdbcUtilsServiceImpl:executeQuery START");
		try {
			Thread.currentThread().sleep(ApplicationContextContainer.getRandomSleepTime());
		} catch(Throwable th){
		}
		log.info("JdbcUtilsServiceImpl:executeQuery END");
		return new ArrayList();
	}

	// -------------------------------------------------------- PRIVATE METHODS
	// ------------------------------------------------------ PROTECTED METHODS
	// --------------------------------------------- ADVANCED GETTERS & SETTERS
	// ------------------------------------------------------ GETTERS & SETTERS
 }
