package com.ho.test.perf.measure.utils;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Gives an access to Spring Container
 * @author Huseyin
 */
public class ApplicationContextContainer {
	
    // ------------------------------------------------------------------ LOG4J
	private static Log log = LogFactory.getLog(ApplicationContextContainer.class);

    // -------------------------------------------------------------- CONSTANTS
	private final static String SPRING_BUSINESS_CONFIG_XML = "spring-business-config.xml";
    

    // ----------------------------------------------------- PRIVATE ATTRIBUTES
    /**
     * Instance
     */
    private static ApplicationContextContainer instance = null;
    
    /**
     * Contains the spring configuration.
     */
    private ClassPathXmlApplicationContext ctx = null;

    // ------------------------------------------------------------- EXCEPTIONS
    // ------------------------------------------------------- INTERNAL CLASSES
    // ----------------------------------------------------------- CONSTRUCTORS
    private ApplicationContextContainer() {}
    // --------------------------------------------------------- PUBLIC METHODS
    
    /**
     * Getinstance method.
     */
    public static synchronized ApplicationContextContainer getInstance() {
        return getInstance(SPRING_BUSINESS_CONFIG_XML);
    }
    public static synchronized ApplicationContextContainer getInstance(String springContextFile) {
    	if (null == instance) {
    		instance = new ApplicationContextContainer();
    		instance.ctx = new ClassPathXmlApplicationContext();  
    		instance.ctx.setConfigLocation(springContextFile);
    		instance.ctx.refresh();
        } // end-if
        return instance;
    }
    
    /**
     * Retrieve the spring bean corresponding to the given key.
     * @param key
     * @return
     */
    public static Object getBean(String key) {
        return getInstance().ctx.getBean(key);
    }
    
    public ClassPathXmlApplicationContext getContext() {
        return ctx;
    }
    
    

	/**
	 * Returns a number in milliseconds between 1000 (1sec) and 5000 (5sec)
	 * @return
	 */
	public static long getRandomSleepTime(){
		int lower = 1000;
		int higher = 5000;

		long random = (long)(Math.random() * (higher-lower)) + lower;
		return random;
	}
    
    // -------------------------------------------------------- PRIVATE METHODS
    // ------------------------------------------------------ PROTECTED METHODS
    // --------------------------------------------- ADVANCED GETTERS & SETTERS
    // ------------------------------------------------------ GETTERS & SETTERS
}
